<?php
/**
 * 
 * $Id: project.php 130 2020-03-17 10:25:32Z munix9 $
 * 
 */

require_once '../../../config.php';

require_once $config->classPath . '/modules/time/time.php';
require_once $config->classPath . '/modules/project/treeDyn.php';
require_once $config->classPath . '/modules/project/member.php';
require_once $config->classPath . '/modules/project/tree.php';

$projectMember->setProjectOverviewListAll(!empty($config->project_overview_listall));

$milestones = array(
    array('percentage' =>   0, 'color' => 'green'),
    array('percentage' => 101, 'color' => 'yellow'),
    array('percentage' => 125, 'color' => 'red'),
);

$filter = @$_POST['filter'];
if (!in_array($filter, ['all','active','closed'])) {
    $filter = 'active';
}
$active = $closed = $all = '';
$$filter = 'boldbutton';

$_error = false;
if (!$projectMember->isManager() && !$projectMember->canProjectOverviewListAll()) {
    $_error = true;
    $applError->set('You are not a project manager of any project!');
} else {
    $time->preset();
    $time->setSelect('SUM(durationSec) AS durationSumSec,projectTree_id,maxDuration');
    if (!$user->isAdmin() && !$projectMember->canProjectOverviewListAll()) {
        $myProjects = $projectMember->getManagerProjects();
        foreach ($myProjects as $aProject) {
            $projectIds[] = $aProject['projectTree_id'];
        }
        $time->setWhere('projectTree_id IN (' . implode(',', $projectIds) . ')');
    }
    $time->addWhere(TABLE_TASK . '.calcTime=1 AND ' . TABLE_TASK . '.needsProject=1');

    switch ($config->project_overview_sort) {
        case 0:
            $time->setOrder(TABLE_PROJECTTREE . '.l');
            break;
        case 1:
            $time->setOrder(TABLE_PROJECTTREE . '.parent,' . TABLE_PROJECTTREE . '.endDate,' . TABLE_PROJECTTREE . '.name');
            break;
        case 2:
            $time->setOrder(TABLE_PROJECTTREE . '.endDate,' . TABLE_PROJECTTREE . '.name');
            break;
    }

    $time->setGroup('projectTree_id');
    $times = $time->getAll();
    if ($times) {
        $projectTree = modules_project_tree::getInstance();
        foreach ($times as $key => $aTime) {
            $times[$key]['_durationSum'] = $time->_calcDuration($aTime['durationSumSec'],'decimal');
            $times[$key]['_name'] = $projectTreeDyn->getPathAsString($aTime['projectTree_id']);
            // we dont want to divide by zero
            if (!empty($times[$key]['maxDuration'])) {
                $times[$key]['_percent'] = round(((float)$times[$key]['_durationSum'] / $times[$key]['maxDuration']) * 100, 2);
                $times[$key]['_remainDec'] = $times[$key]['maxDuration'] - str_replace(',', '.', $times[$key]['_durationSum']);
                $times[$key]['_remainFmt'] = number_format($times[$key]['_remainDec'], 2, ',', '');
            }
            $times[$key]['_isProjectAvail'] = $projectTree->isAvailable($times[$key]['projectTree_id'], time());
        }

        // filter projects according selection
        $filteredTimes = array();
        foreach ($times as $key => $aTime) {
            if ($filter == 'all') {
                $filteredTimes[$key] = $aTime;
            } else if ($filter == 'closed') {
                if (!$times[$key]['_isProjectAvail']) {
                    $filteredTimes[$key] = $aTime;
                }
            } else {
                if ($times[$key]['_isProjectAvail']) {
                    $filteredTimes[$key] = $aTime;
                }
            }
        }

        $times = $filteredTimes;
        unset($filteredTimes);

        foreach ($times as $key => $aTime) {
            if (isset($times[$key]['_percent'])) {
                $times[$key]['_width'] = $times[$key]['_percent'];
            } else {
                $times[$key]['_width'] = 0;
            }
            foreach ($milestones as $aMilestone) {
                if (isset($times[$key]['_percent']) && ($times[$key]['_percent'] < $aMilestone['percentage'])) {
                    break;
                }
                $lastColor = $aMilestone['color'];
            }
            $times[$key]['_color'] = $lastColor;
        }
    } else {
        $applMessage->set('There are no projects with more than zero hours, that you are allowed to see.');
    }
}

require_once $config->finalizePage;
