<?php
/**
 * 
 * $Id$
 * 
 */

require_once '../../../config.php';

require_once $config->classPath . '/modules/time/time.php';
require_once $config->classPath . '/modules/project/treeDyn.php';
require_once $config->classPath . '/modules/project/member.php';
require_once $config->classPath . '/modules/project/tree.php';

if (empty($config->showProjectEvaluation)) {
    require_once 'HTTP/Header.php';
    HTTP_Header::redirect($config->home);
}

$projectMember->setProjectOverviewListAll(!empty($config->project_overview_listall));

$filter = @$_POST['filter'];
if (!in_array($filter, ['all','active','closed'])) {
    $filter = 'active';
}
$active = $closed = $all = '';
$$filter = 'boldbutton';

$projectTree = modules_project_tree::getInstance();

$show = &$session->temp->time_index2;

// this takes care of saving the show-parameters in the session
// and retreiving them from there
if (isset($_REQUEST['show'])) {
    $show = $_REQUEST['show'];
    $show['projectTree_id'] = (int)$show['projectTree_id'];
}

// convert the dates
if (isset($show['humanDateFrom'])) {
    $dateFrom = explode('.', $show['humanDateFrom']);
}
if (isset($show['humanDateUntil'])) {
    $dateUntil = explode('.', $show['humanDateUntil']);
}
if (isset($dateFrom)) {
    $show['dateFrom'] = mktime(
        0, 0, 0, (int)$dateFrom[1], (int)$dateFrom[0], $dateFrom[2]?(int)$dateFrom[2]:date('Y')
    );
} else {
    $show['dateFrom'] = time();
}
if (isset($dateUntil)) {
    $show['dateUntil'] = mktime(
        0, 0, 0, (int)$dateUntil[1], (int)$dateUntil[0], $dateUntil[2]?(int)$dateUntil[2]:date('Y')
    );
} else {
    $show['dateUntil'] = time();
}

// convert the dateUntil and dateFrom back to humanDate...
$show['humanDateFrom'] = date('d.m.Y', $show['dateFrom']);
$show['humanDateUntil'] = date('d.m.Y', $show['dateUntil']);

$allFolders = $projectTree->getAll();
$projectList = [];

$_error = false;
if (!$projectMember->isManager() && !$projectMember->canProjectOverviewListAll()) {
    $_error = true;
    $applError->set('You are not a project manager of any project!');
} else if (isset($_REQUEST['action_show']) && !empty($show['projectTree_id'])) {
    $projectFolders = $projectTree->getNode($show['projectTree_id']);

    $projectHelper = [];
    foreach ($projectFolders as $aFolder) {
        $projectHelper[$aFolder['id']] = $projectTree->isAvailable($aFolder['id'], time());
    }

    $time->preset();
    $time->setSelect('SUM(' . TABLE_TIME . '.durationSec) AS durationSumSec,' . TABLE_TIME . '.projectTree_id');
    $time->addWhere(TABLE_TASK . '.calcTime=1 AND ' . TABLE_TASK . '.needsProject=1');
    $time->addWhere(TABLE_TIME . '.timestamp >= ' . $show['dateFrom'] . ' AND ' .
                    TABLE_TIME . '.timestamp < ' . ($show['dateUntil'] + 60 * 60 * 24));
    $time->addWhere(TABLE_TIME . '.projectTree_id IN (' . implode(',', array_keys($projectHelper)) . ')');
    $time->setOrder(TABLE_PROJECTTREE . '.l');
    $time->setGroup('projectTree_id');

    $times = $time->getAll();
    if ($times) {
        foreach ($projectFolders as $aFolder) {
            $duration = 0;
            $sums = isset($projectList[$aFolder['id']]['sums']) ? $projectList[$aFolder['id']]['sums'] : 0;
            $children = $projectTree->getAllChildrenIds($aFolder['id']);
            foreach ($times as $aTime) {
                if ($aTime['projectTree_id'] == $aFolder['id']) {
                    if ($filter == 'all' ||
                       ($filter == 'closed' && !$projectHelper[$aFolder['id']]) ||
                       ($filter == 'active' && $projectHelper[$aFolder['id']])) {
                        $duration = $aTime['durationSumSec'];
                    }
                } else if (!empty($children) && in_array($aTime['projectTree_id'], $children)) {
                    if ($filter == 'all' ||
                       ($filter == 'closed' && !$projectHelper[$aTime['projectTree_id']]) ||
                       ($filter == 'active' && $projectHelper[$aTime['projectTree_id']])) {
                        $sums += $aTime['durationSumSec'];
                    }
                } else {
                    continue;
                }
                $projectList[$aFolder['id']] = [
                    'id' => $aFolder['id'],
                    'name' => $aFolder['name'],
                    'level' => $aFolder['level'],
                    'time' => $duration,
                    'sums' => $sums,
                    'total' => 0,
                    'isProjectAvail' => $projectHelper[$aFolder['id']],
                ];
            }
        }

        if (!empty($projectList)) {
            foreach ($projectList as $key => $val) {
                if (empty($val['time']) && empty($val['sums'])) {
                    unset($projectList[$key]);
                    continue;
                }
                if (!empty($val['sums'])) {
                    $val['total'] = $projectList[$key]['total'] = $projectList[$key]['time'] + $projectList[$key]['sums'];
                }
                foreach ($val as $key2 => $val2) {
                    if (($key2 == 'time' || $key2 == 'sums' || $key2 == 'total') && !empty($val2)) {
                        $projectList[$key][$key2] = $time->_calcDuration($val2, 'decimal');
                    }
                }
            }
        }
    }

    if (empty($projectList)) {
        $applMessage->set('There are no projects with more than zero hours.');
    }
}

require_once $config->finalizePage;
